
package classicaltm;

import javax.swing.SwingUtilities;

import classicaltm.gui.GUI;

/**
 * An application that simulates Turing machines.
 * @author Ziyed, Willem
 */
public class TuringSimulator {
    
    /**
     * The current version of the application.
     */
    public static final String VERSION = "1.1";
	
	/**
	 * The main GUI of the application.
	 */
	private static GUI gui;
	
    /**
     * Starts the application.
     * @param args The command line arguments (ignored).
     */
    public static void main(String[] args) {
    	SwingUtilities.invokeLater(new Runnable() {
			
			@Override
			public void run() {
		        gui = new GUI();
		        gui.setSize(800, 450);
		        gui.setLocationRelativeTo(null);
		        gui.setVisible(true);
			}
		});
    }  
}
