package classicaltm.gui;

import java.awt.BorderLayout;
import java.awt.Font;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

/**
 * A panel in which the user can edit the Turing machine to simulate.
 */
public class EditorTab extends JPanel {
	
	JTextArea programArea;
    JScrollPane scrollPane;
	TextLineNumber tln;
	
	/**
	 * Creates a new editor tab.
	 */
	public EditorTab() {
		super(new BorderLayout());
		programArea = new JTextArea(10, 50);
		programArea.setFont(new Font("monospaced", Font.PLAIN, 12));
        scrollPane = new JScrollPane(programArea);
        tln = new TextLineNumber(programArea);
        scrollPane.setRowHeaderView(tln);
		add(scrollPane);
	}
	
	/**
	 * Returns the program currently written in the editor tab.
	 * @return The program text.
	 */
	public String getProgramText() {
		return programArea.getText();
	}
}
