package classicaltm.model;

import java.util.ArrayList;

/**
 * This class implements an infinite tape.
 *
 * Objects from type <code>E</code> will be used as tape symbols;
 * <code>null</code> represents a blank.
 *
 * @param <E> The type of symbols on the tape.
 */
public class Tape<E> {

    /**
     * Constructs a new tape, where all elements are initialized to blanks
     * (<code>null</code>).
     */
    public Tape() {
        //TODO implement Tape constructor
    }

    /**
     * Returns the current symbol under the tape head.
     *
     * @return The symbol under the tape read.
     */
    public E readSymbol() {
        //TODO implement method reads the current symbol under the tape head
    }

    /**
     * Writes the given symbol to the current position under the tape head.
     *
     * @param newSymbol The new symbol to write.
     */
    public void writeSymbol(E newSymbol) {
        //TODO implement method that writes a symbol on the current tape head position on the tape
    }

    /**
     * Shifts the tape head one place to the left.
     */
    public void shiftLeft() {
        //TODO implement method that shifts the tape head a single position to the left
    }

    /**
     * Shifts the tape head one place to the right.
     */
    public void shiftRight() {
        //TODO implement method that shifts the tape head a single position to the right
    }

    /**
     * Places the given input on the tape. This is called to initialize the tape
     * on the start of a simulation.
     *
     * This method should put the given symbols on the tape from left to right
     * (so the first character of the string should be placed on the leftmost
     * cell, and so on). When the method finishes, the tape head should be
     * placed on the first character of the input.
     *
     * @param input The input symbols to place on the tape.
     */
    public void placeInput(ArrayList<E> input) {
        //TODO method that places input on the Tape in Tape class
    }

    /**
     * Reads the output that is currently on the tape.
     *
     * The result should be a list of the non-blank symbols on the tape, from
     * left to right. Reading the output stops at blank symbols, so for example
     * on the tape
     * <pre>
     * # # a b c # # d e f # #
     *       ^
     * </pre> this method will return <code>"abc"</code>.
     *
     * @return The output on the tape.
     */
    public ArrayList<E> readOutput() {
        //TODO implement output method
    }

    /**
     * Returns a symbol that is not currently under the tape head. This should
     * of course not be used in the Turing machine emulator (hence the name
     * <code>peek</code>), but it is used in the visualisation.
     *
     * @param location The location to read from. <code>0</code> stands for the
     * position of the tape head; the elements to the left of it are numbered
	 * <code>-1, -2, -3, ...</code>; the elements to the right of it are
     * numbered <code>1, 2, 3, ...</code>.
     * @return The symbol at the specified location.
     */
    public E peek(int location) {
        //TODO implement peek method as described in Javadoc
    }

    /**
     * Returns the absolute position on the tape. This should of course not be
     * used in the Turing machine emulator, but it is used in the visualisation.
     *
     * @return The absolute position on the tape.
     */
    public int getPosition() {
        //TODO implement method to return position
    }

    /**
     * Resets the tape, that is, ensures that the entire tape is empty.
     *
     * A call to {@link #getPosition()} should return <code>0</code> after this
     * method returns.
     */
    public void reset() {
        //TODO implement reset method
    }
}
