package classicaltm.model;

/**
 * This class implements the behaviour of a Turing machine.
 */
public class TuringMachine {

    /**
     * Creates a new Turing machine with an empty tape, that will execute the
     * given Turing program.
     *
     * The Turing machine should start in state "q0".
     *
     * @param program The program to execute.
     */
    public TuringMachine(TuringProgram program) {
        //TODO implement TuringMachine constructor
    }

    /**
     * Returns the tape of the Turing machine.
     *
     * @return The tape.
     */
    public Tape<Character> getTape() {
        //TODO implement getter for the tape
    }

    /**
     * Returns the name of the current state.
     *
     * @return The current state name.
     */
    public String getCurrentState() {
        //TODO implement getter for the current state
    }

    /**
     * Returns the Turing program this machine is executing.
     *
     * @return The Turing program of the machine.
     */
    public TuringProgram getTuringProgram() {
        //TODO implement getter for the Turing program currently being simulated
    }

    /**
     * Checks which transition is possible at the moment. (The step is not
     * actually executed, however.)
     *
     * @return The transition that can be done at the moment, or
     * <code>null</code> if no transition can be done anymore. If the Turing
     * machine can perform more than one step at the moment, any of the possible
     * transitions may be returned by this method.
     */
    public Transition activeTransition() {
        //TODO implement active transition method
    }

    /**
     * Performs a single transition.
     *
     * If no step could be performed at all, nothing should happen.
     *
     * If the Turing machine can perform more than one step at the moment, any
     * of the possible transitions may be taken.
     */
    public void step() {
        //TODO implement single step method
    }

    /**
     * Returns the number of steps that have been executed until now.
     *
     * @return The step count.
     */
    public int getStepCount() {
        //TODO implement getter for step count
    }

    /**
     * Resets the Turing machine.
     *
     * This method restores the Turing machine to the state like it was when it
     * was constructed, that is:
     * <ul>
     * <li>it empties the tape;</li>
     * <li>it resets the current state to "q0";</li>
     * <li>it resets the step count.</li>
     * </ul>
     */
    public void reset() {
        //TODO implement reset method
    }
}
